## ros-rolling-moveit-servo 2.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(moveit_servo)

# C++ Libraries #################################################

# Core C++ library for calculations and collision checking.
# Provides interface used by the component node.
set(SERVO_LIB_NAME moveit_servo_lib)
# C++ library containing the parameters initialization
# - This is intended to use with the component node when you
# -   need to read the parameters loaded into servo in a separate
# -   node.
set(SERVO_PARAM_LIB_NAME ${SERVO_LIB_NAME}_parameters)

# Pose Tracking
set(POSE_TRACKING pose_tracking)

# Component Nodes (Shared libraries) ############################
set(SERVO_COMPONENT_NODE servo_node)
set(SERVO_CONTROLLER_INPUT servo_controller_input)

# Executable Nodes ##############################################
set(SERVO_NODE_MAIN_NAME servo_node_main)
set(POSE_TRACKING_DEMO_NAME servo_pose_tracking_demo)
set(FAKE_SERVO_CMDS_NAME fake_command_publisher)

#################################################################

# Common cmake code applied to all moveit packages
find_package(moveit_common REQUIRED)
moveit_package()

find_package(ament_cmake REQUIRED)
find_package(control_msgs REQUIRED)
find_package(control_toolbox REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(moveit_core REQUIRED)
find_package(moveit_msgs REQUIRED)
find_package(moveit_ros_planning REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(std_srvs REQUIRED)
find_package(tf2_eigen REQUIRED)
find_package(trajectory_msgs REQUIRED)

find_package(eigen3_cmake_module REQUIRED)
find_package(Eigen3 REQUIRED)

set(THIS_PACKAGE_INCLUDE_DEPENDS
  control_msgs
  control_toolbox
  geometry_msgs
  moveit_core
  moveit_msgs
  moveit_ros_planning
  pluginlib
  rclcpp
  rclcpp_components
  sensor_msgs
  std_msgs
  std_srvs
  tf2_eigen
  trajectory_msgs
)

include_directories(
  include
)

###################
## C++ Libraries ##
###################

# This library provides a way of loading parameters for servo
add_library(${SERVO_PARAM_LIB_NAME} SHARED
  src/servo_parameters.cpp
  src/parameter_descriptor_builder.cpp
)
set_target_properties(${SERVO_PARAM_LIB_NAME} PROPERTIES VERSION "${${PROJECT_NAME}_VERSION}")
ament_target_dependencies(${SERVO_PARAM_LIB_NAME} ${THIS_PACKAGE_INCLUDE_DEPENDS})

# This library provides a C++ interface for sending realtime twist or joint commands to a robot
add_library(${SERVO_LIB_NAME} SHARED
  # These files are used to produce differential motion
  src/collision_check.cpp
  src/enforce_limits.cpp
  src/servo.cpp
  src/servo_calcs.cpp
)
set_target_properties(${SERVO_LIB_NAME} PROPERTIES VERSION "${${PROJECT_NAME}_VERSION}")
ament_target_dependencies(${SERVO_LIB_NAME} ${THIS_PACKAGE_INCLUDE_DEPENDS})
target_link_libraries(${SERVO_LIB_NAME} ${SERVO_PARAM_LIB_NAME})

add_library(${POSE_TRACKING} SHARED src/pose_tracking.cpp)
ament_target_dependencies(${POSE_TRACKING} ${THIS_PACKAGE_INCLUDE_DEPENDS})
target_link_libraries(${POSE_TRACKING} ${SERVO_LIB_NAME})

#####################
## Component Nodes ##
#####################

# Add and export library to run as a ROS node component, and receive commands via topics
add_library(${SERVO_COMPONENT_NODE} SHARED src/servo_node.cpp)
ament_target_dependencies(${SERVO_COMPONENT_NODE} ${THIS_PACKAGE_INCLUDE_DEPENDS})
target_link_libraries(${SERVO_COMPONENT_NODE} ${SERVO_LIB_NAME})
rclcpp_components_register_nodes(${SERVO_COMPONENT_NODE} "moveit_servo::ServoNode")

# Add executable for using a controller
add_library(${SERVO_CONTROLLER_INPUT} SHARED src/teleop_demo/joystick_servo_example.cpp)
ament_target_dependencies(${SERVO_CONTROLLER_INPUT} ${THIS_PACKAGE_INCLUDE_DEPENDS})
rclcpp_components_register_nodes(${SERVO_CONTROLLER_INPUT} "moveit_servo::JoyToServoPub")

######################
## Executable Nodes ##
######################

# An executable node for the servo server
add_executable(${SERVO_NODE_MAIN_NAME} src/servo_node_main.cpp)
target_link_libraries(${SERVO_NODE_MAIN_NAME} ${SERVO_COMPONENT_NODE})
ament_target_dependencies(${SERVO_NODE_MAIN_NAME} ${THIS_PACKAGE_INCLUDE_DEPENDS})

# An example of pose tracking
add_executable(${POSE_TRACKING_DEMO_NAME} src/cpp_interface_demo/pose_tracking_demo.cpp)
target_link_libraries(${POSE_TRACKING_DEMO_NAME} ${POSE_TRACKING})
ament_target_dependencies(${POSE_TRACKING_DEMO_NAME} ${THIS_PACKAGE_INCLUDE_DEPENDS})

# Add executable to publish fake servo commands for testing/demo purposes
add_executable(${FAKE_SERVO_CMDS_NAME} test/publish_fake_jog_commands.cpp)
ament_target_dependencies(${FAKE_SERVO_CMDS_NAME}
  rclcpp
  geometry_msgs
  std_srvs
)

#############
## Install ##
#############

# Install Libraries
install(
  TARGETS
    ${SERVO_LIB_NAME}
    ${SERVO_LIB_NAME}_parameters
    ${POSE_TRACKING}
    ${SERVO_COMPONENT_NODE}
    ${SERVO_CONTROLLER_INPUT}
  EXPORT export_${PROJECT_NAME}
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION bin
  INCLUDES DESTINATION include
)

# Install Binaries
install(
  TARGETS
    ${SERVO_NODE_MAIN_NAME}
    ${CPP_DEMO_NAME}
    ${POSE_TRACKING_DEMO_NAME}
    ${FAKE_SERVO_CMDS_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

# Install include, launch, config directories
install(DIRECTORY include/ DESTINATION include)
install(DIRECTORY launch DESTINATION share/${PROJECT_NAME})
install(DIRECTORY config DESTINATION share/${PROJECT_NAME})

ament_export_targets(export_${PROJECT_NAME} HAS_LIBRARY_TARGET)
ament_export_dependencies(${THIS_PACKAGE_INCLUDE_DEPENDS})

#############
## TESTING ##
#############

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ros_testing REQUIRED)
  find_package(Boost REQUIRED COMPONENTS filesystem)

  # These don't pass yet, disable them for now
  set(ament_cmake_copyright_FOUND TRUE)
  set(ament_cmake_cppcheck_FOUND TRUE)
  set(ament_cmake_cpplint_FOUND TRUE)
  set(ament_cmake_flake8_FOUND TRUE)
  set(ament_cmake_uncrustify_FOUND TRUE)

  # Run all lint tests in package.xml except those listed above
  ament_lint_auto_find_test_dependencies()

  # Unit test for ServoCalcs
  # TODO (vatanaksoytezer): Rewrite this similar to enforce limits test
  # ament_add_gtest_executable(
  #   unit_test_servo_calcs
  #   test/unit_test_servo_calcs.cpp
  # )
  # target_link_libraries(unit_test_servo_calcs ${SERVO_LIB_NAME})
  # ament_target_dependencies(unit_test_servo_calcs ${THIS_PACKAGE_INCLUDE_DEPENDS} Boost)
  # add_ros_test(test/launch/unit_test_servo_calcs.test.py TIMEOUT 120 ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # Servo integration launch test
  ament_add_gtest_executable(test_servo_integration
      test/test_servo_interface.cpp
      test/servo_launch_test_common.hpp
  )
  target_link_libraries(test_servo_integration ${SERVO_PARAM_LIB_NAME})
  ament_target_dependencies(test_servo_integration ${THIS_PACKAGE_INCLUDE_DEPENDS})
  add_ros_test(test/launch/test_servo_integration.test.py TIMEOUT 120 ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # Servo collision checking integration test
  ament_add_gtest_executable(test_servo_collision
        test/test_servo_collision.cpp
        test/servo_launch_test_common.hpp
  )
  target_link_libraries(test_servo_collision ${SERVO_PARAM_LIB_NAME})
  ament_target_dependencies(test_servo_collision ${THIS_PACKAGE_INCLUDE_DEPENDS})
  add_ros_test(test/launch/test_servo_collision.test.py TIMEOUT 120 ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # Servo singularity checking integration test
  ament_add_gtest_executable(test_servo_singularity
        test/test_servo_singularity.cpp
        test/servo_launch_test_common.hpp
  )
  target_link_libraries(test_servo_singularity ${SERVO_PARAM_LIB_NAME})
  ament_target_dependencies(test_servo_singularity ${THIS_PACKAGE_INCLUDE_DEPENDS})
  add_ros_test(test/launch/test_servo_singularity.test.py TIMEOUT 120 ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # pose_tracking
  ament_add_gtest_executable(test_servo_pose_tracking
        test/pose_tracking_test.cpp
  )
  ament_target_dependencies(test_servo_pose_tracking ${THIS_PACKAGE_INCLUDE_DEPENDS})
  target_link_libraries(test_servo_pose_tracking ${POSE_TRACKING})
  add_ros_test(test/launch/test_servo_pose_tracking.test.py TIMEOUT 120 ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # basic_servo_tests
  ament_add_gtest_executable(basic_servo_tests
        test/basic_servo_tests.cpp
  )
  ament_target_dependencies(basic_servo_tests ${THIS_PACKAGE_INCLUDE_DEPENDS})
  target_link_libraries(basic_servo_tests ${POSE_TRACKING})
  add_ros_test(test/launch/test_basic_servo.test.py TIMEOUT 120 ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

  # Enforce limits unit tests
  ament_add_gtest(enforce_limits_tests
    test/enforce_limits_tests.cpp
  )
  target_link_libraries(enforce_limits_tests ${SERVO_LIB_NAME})

endif()

ament_package()

=== debian/changelog ===
ros-rolling-moveit-servo (2.4.0-1focal) focal; urgency=high

  * Remove 'using namespace' from header files. (#994 <https://github.com/ros-planning/moveit2/issues/994>)
  * Servo: re-order velocity limit check & minor cleanup (#956 <https://github.com/ros-planning/moveit2/issues/956>)
  * moveit_build_options()
    Declare common build options like CMAKE_CXX_STANDARD, CMAKE_BUILD_TYPE,
    and compiler options (namely warning flags) once.
    Each package depending on moveit_core can use these via moveit_build_options().
  * Contributors: AndyZe, Cory Crean, Robert Haschke

 -- Blake Anderson <blakeanderson@utexas.edu>  Thu, 20 Jan 2022 07:00:00 -0000

ros-rolling-moveit-servo (2.3.2-1focal) focal; urgency=high



 -- Blake Anderson <blakeanderson@utexas.edu>  Wed, 29 Dec 2021 07:00:00 -0000

ros-rolling-moveit-servo (2.3.1-1focal) focal; urgency=high

  * Servo: fix -Wunused-private-field (#937 <https://github.com/ros-planning/moveit2/issues/937>)
  * Add codespell to precommit, fix A LOT of spelling mistakes (#934 <https://github.com/ros-planning/moveit2/issues/934>)
  * Add descriptions and default values to servo parameters (#799 <https://github.com/ros-planning/moveit2/issues/799>)
  * Update README (#812 <https://github.com/ros-planning/moveit2/issues/812>)
  * Enforce package.xml format 3 Schema (#779 <https://github.com/ros-planning/moveit2/issues/779>)
  * Update Maintainers of MoveIt package (#697 <https://github.com/ros-planning/moveit2/issues/697>)
  * moveit_servo: Fix ACM for collision checking & PSM's scene monitor topic (#673 <https://github.com/ros-planning/moveit2/issues/673>)
  * Fix initialization of PSM publisher in servo (#771 <https://github.com/ros-planning/moveit2/issues/771>)
  * Move initialization of ServoNode into constructor (#761 <https://github.com/ros-planning/moveit2/issues/761>)
  * Fix missing test depend in servo (#759 <https://github.com/ros-planning/moveit2/issues/759>)
  * Find/replace deprecated spawner.py (#737 <https://github.com/ros-planning/moveit2/issues/737>)
  * Fix the servo executable name (#746 <https://github.com/ros-planning/moveit2/issues/746>)
  * Use rclcpp::SystemDefaultsQoS in Servo (#721 <https://github.com/ros-planning/moveit2/issues/721>)
  * Use multi-threaded component container, do not use intraprocess comms in Servo (#723 <https://github.com/ros-planning/moveit2/issues/723>)
  * Disable use_intra_process_comms in servo launch files (#722 <https://github.com/ros-planning/moveit2/issues/722>)
  * Servo: minor fixups (#2759 <https://github.com/ros-planning/moveit/issues/2759>)
  * Contributors: AndyZe, Dave Coleman, David V. Lu!!, Henning Kayser, Jafar Abdi, Robert Haschke, Stephanie Eng, Tyler Weaver, toru-kuga

 -- Blake Anderson <blakeanderson@utexas.edu>  Thu, 23 Dec 2021 07:00:00 -0000

ros-rolling-moveit-servo (2.3.0-1focal) focal; urgency=high

  * Make TF buffer & listener in PSM private (#654 <https://github.com/ros-planning/moveit2/issues/654>)
  * Rename ServoServer to ServerNode (#649 <https://github.com/ros-planning/moveit2/issues/649>)
  * Fix std::placeholders namespace conflict (#713 <https://github.com/ros-planning/moveit2/issues/713>)
  * Publish singularity condition to ~/servo_server/condition (#695 <https://github.com/ros-planning/moveit2/issues/695>)
  * Skip publishing to Servo topics if input commands are stale (#707 <https://github.com/ros-planning/moveit2/issues/707>)
  * Delete duplicate entry in Servo launch file (#684 <https://github.com/ros-planning/moveit2/issues/684>)
  * Fix cmake warnings (#690 <https://github.com/ros-planning/moveit2/issues/690>)
    * Fix -Wformat-security
    * Fix -Wunused-variable
    * Fix -Wunused-lambda-capture
    * Fix -Wdeprecated-declarations
    * Fix clang-tidy, readability-identifier-naming in moveit_kinematics
  * Add standalone executable for Servo node, and example launch file (#621 <https://github.com/ros-planning/moveit2/issues/621>)
  * Validate return of getJointModelGroup in ServoCalcs (#648 <https://github.com/ros-planning/moveit2/issues/648>)
  * Migrate to joint_state_broadcaster (#657 <https://github.com/ros-planning/moveit2/issues/657>)
  * Add gripper and traj control packages as run dependencies (#636 <https://github.com/ros-planning/moveit2/issues/636>)
  * Fix warnings in Galactic and Rolling (#598 <https://github.com/ros-planning/moveit2/issues/598>)
    * Use __has_includes preprocessor directive for deprecated headers
    * Fix parameter template types
    * Proper initialization of smart pointers, rclcpp::Duration
  * Remove stray semicolon (#613 <https://github.com/ros-planning/moveit2/issues/613>)
  * Re-Enable Servo Tests (#603 <https://github.com/ros-planning/moveit2/issues/603>)
  * Fix missing include in servo example (#604 <https://github.com/ros-planning/moveit2/issues/604>)
  * Document the difference between Servo pause/unpause and start/stop (#605 <https://github.com/ros-planning/moveit2/issues/605>)
  * Wait for complete state duration fix (#590 <https://github.com/ros-planning/moveit2/issues/590>)
  * Delete "stop distance"-based collision checking (#564 <https://github.com/ros-planning/moveit2/issues/564>)
  * Fix loading joint_limits.yaml in demo and test launch files (#544 <https://github.com/ros-planning/moveit2/issues/544>)
  * Fixes for Windows (#530 <https://github.com/ros-planning/moveit2/issues/530>)
  * Refactor out velocity limit enforcement with test (#540 <https://github.com/ros-planning/moveit2/issues/540>)
  * Refactor moveit_servo::LowPassFilter to be assignable (#572 <https://github.com/ros-planning/moveit2/issues/572>)
  * Fix MoveIt Servo compilation on macOS (#555 <https://github.com/ros-planning/moveit2/issues/555>)
  * Fix segfault if servo collision checking is disabled (#568 <https://github.com/ros-planning/moveit2/issues/568>)
  * Remove gtest include from non-testing source (#2747 <https://github.com/ros-planning/moveit2/issues/2747>)


=== debian/control ===
Source: ros-rolling-moveit-servo
Section: misc
Priority: optional
Maintainer: Blake Anderson <blakeanderson@utexas.edu>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake, ros-rolling-ament-cmake-gtest, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-control-msgs, ros-rolling-control-toolbox, ros-rolling-controller-manager, ros-rolling-geometry-msgs, ros-rolling-moveit-common, ros-rolling-moveit-core, ros-rolling-moveit-msgs, ros-rolling-moveit-resources-panda-moveit-config, ros-rolling-moveit-ros-planning-interface, ros-rolling-pluginlib, ros-rolling-ros-testing, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-std-srvs, ros-rolling-tf2-eigen, ros-rolling-trajectory-msgs, ros-rolling-ros-workspace
Homepage: https://ros-planning.github.io/moveit_tutorials
Standards-Version: 3.9.2

Package: ros-rolling-moveit-servo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-control-msgs, ros-rolling-control-toolbox, ros-rolling-geometry-msgs, ros-rolling-gripper-controllers, ros-rolling-joint-state-broadcaster, ros-rolling-joint-trajectory-controller, ros-rolling-joy, ros-rolling-moveit-core, ros-rolling-moveit-msgs, ros-rolling-moveit-ros-planning-interface, ros-rolling-pluginlib, ros-rolling-robot-state-publisher, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-std-srvs, ros-rolling-tf2-eigen, ros-rolling-tf2-ros, ros-rolling-trajectory-msgs, ros-rolling-ros-workspace
Description: Provides real-time manipulator Cartesian and joint servoing.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-moveit-servo//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-moveit-servo 2.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)
project(moveit_servo LANGUAGES CXX)

# Common cmake code applied to all moveit packages
find_package(moveit_common REQUIRED)
moveit_package()

set(THIS_PACKAGE_INCLUDE_DEPENDS
  control_msgs
  geometry_msgs
  moveit_core
  moveit_msgs
  moveit_ros_planning
  pluginlib
  rclcpp
  rclcpp_components
  realtime_tools
  sensor_msgs
  std_msgs
  std_srvs
  tf2_eigen
  trajectory_msgs
)

find_package(ament_cmake REQUIRED)
find_package(eigen3_cmake_module REQUIRED)
find_package(Eigen3 REQUIRED)
find_package(generate_parameter_library REQUIRED)
foreach(Dependency IN ITEMS ${THIS_PACKAGE_INCLUDE_DEPENDS})
  find_package(${Dependency} REQUIRED)
endforeach()

include_directories(
  include
)

###################
## C++ Libraries ##
###################

# This library provides a way of loading parameters for servo
generate_parameter_library(
  moveit_servo_lib_parameters
  config/servo_parameters.yaml
)

# This library provides a C++ interface for sending realtime twist or joint commands to a robot
add_library(moveit_servo_lib_cpp SHARED
  src/collision_monitor.cpp
  src/servo.cpp
  src/utils/common.cpp
  src/utils/command.cpp

)
set_target_properties(moveit_servo_lib_cpp PROPERTIES VERSION "${moveit_servo_VERSION}")
target_link_libraries(moveit_servo_lib_cpp moveit_servo_lib_parameters)
ament_target_dependencies(moveit_servo_lib_cpp ${THIS_PACKAGE_INCLUDE_DEPENDS})

add_library(moveit_servo_lib_ros SHARED src/servo_node.cpp)
set_target_properties(moveit_servo_lib_ros PROPERTIES VERSION "${moveit_servo_VERSION}")
target_link_libraries(moveit_servo_lib_ros moveit_servo_lib_cpp)
ament_target_dependencies(moveit_servo_lib_ros ${THIS_PACKAGE_INCLUDE_DEPENDS})

######################
## Components ##
######################

rclcpp_components_register_node(
  moveit_servo_lib_ros
  PLUGIN "moveit_servo::ServoNode"
  EXECUTABLE servo_node
)

######################
## Executable Nodes ##
######################

# Executable node for the joint jog demo
add_executable(demo_joint_jog demos/cpp_interface/demo_joint_jog.cpp )
target_link_libraries(demo_joint_jog moveit_servo_lib_cpp)
ament_target_dependencies(demo_joint_jog ${THIS_PACKAGE_INCLUDE_DEPENDS})

# Executable node for the twist demo
add_executable(demo_twist demos/cpp_interface/demo_twist.cpp )
target_link_libraries(demo_twist moveit_servo_lib_cpp)
ament_target_dependencies(demo_twist ${THIS_PACKAGE_INCLUDE_DEPENDS})

# Executable node for the pose demo
add_executable(demo_pose demos/cpp_interface/demo_pose.cpp )
target_link_libraries(demo_pose moveit_servo_lib_cpp)
ament_target_dependencies(demo_pose ${THIS_PACKAGE_INCLUDE_DEPENDS})

# Keyboard control example for servo
add_executable(servo_keyboard_input demos/servo_keyboard_input.cpp)
target_include_directories(servo_keyboard_input PUBLIC include)
ament_target_dependencies(servo_keyboard_input  ${THIS_PACKAGE_INCLUDE_DEPENDS})

#############
## Install ##
#############

# Install Libraries
install(
  TARGETS
    moveit_servo_lib_cpp
    moveit_servo_lib_ros
    moveit_servo_lib_parameters
  EXPORT moveit_servoTargets
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION bin
  INCLUDES DESTINATION include/moveit_servo
)

# Install Binaries
install(
  TARGETS
  demo_joint_jog
  demo_twist
  demo_pose
  servo_node
  servo_keyboard_input
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/moveit_servo
)

# Install include, launch, config directories
install(DIRECTORY include/ DESTINATION include/moveit_servo)
install(DIRECTORY launch DESTINATION share/moveit_servo)
install(DIRECTORY config DESTINATION share/moveit_servo)

ament_export_targets(moveit_servoTargets HAS_LIBRARY_TARGET)
ament_export_dependencies(${THIS_PACKAGE_INCLUDE_DEPENDS})


if(BUILD_TESTING)

    find_package(ament_cmake_gtest REQUIRED)
    find_package(ros_testing REQUIRED)

    ament_add_gtest_executable(moveit_servo_utils_test tests/test_utils.cpp)
    target_link_libraries(moveit_servo_utils_test moveit_servo_lib_cpp)
    ament_target_dependencies(moveit_servo_utils_test ${THIS_PACKAGE_INCLUDE_DEPENDS})
    add_ros_test(tests/launch/servo_utils.test.py TIMEOUT 30 ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

    ament_add_gtest_executable(moveit_servo_cpp_integration_test tests/test_integration.cpp tests/servo_cpp_fixture.hpp)
    target_link_libraries(moveit_servo_cpp_integration_test moveit_servo_lib_cpp)
    ament_target_dependencies(moveit_servo_cpp_integration_test ${THIS_PACKAGE_INCLUDE_DEPENDS})
    add_ros_test(tests/launch/servo_cpp_integration.test.py TIMEOUT 30 ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

    ament_add_gtest_executable(moveit_servo_ros_integration_test tests/test_ros_integration.cpp tests/servo_ros_fixture.hpp)
    ament_target_dependencies(moveit_servo_ros_integration_test ${THIS_PACKAGE_INCLUDE_DEPENDS})
    add_ros_test(tests/launch/servo_ros_integration.test.py TIMEOUT 120 ARGS "test_binary_dir:=${CMAKE_CURRENT_BINARY_DIR}")

endif()

ament_package()

=== debian/changelog ===
ros-rolling-moveit-servo (2.8.0-2jammy) jammy; urgency=high

  * [Servo] Fix Twist transformation  (#2311 <https://github.com/ros-planning/moveit2/issues/2311>)
  * [Servo] Add additional info about twist frame conversion  (#2295 <https://github.com/ros-planning/moveit2/issues/2295>)
    * Update docstring + warning for twist frame conversion
    * Apply suggestions from code review
    Co-authored-by: AndyZe <mailto:andyz@utexas.edu>
    * Suppress old-style-cast warnings
    ---------
    Co-authored-by: AndyZe <mailto:andyz@utexas.edu>
  * [Servo] Refactoring servo (#2224 <https://github.com/ros-planning/moveit2/issues/2224>)
  * Replaced numbers with SystemDefaultsQos() (#2271 <https://github.com/ros-planning/moveit2/issues/2271>)
  * Fix Servo suddenHalt() to halt at previous state, not current (#2229 <https://github.com/ros-planning/moveit2/issues/2229>)
  * Fix the launching of Servo as a node component (#2194 <https://github.com/ros-planning/moveit2/issues/2194>)
    * Fix the launching of Servo as a node component
    * Comment improvement
    Co-authored-by: Sebastian Castro <mailto:4603398+sea-bass@users.noreply.github.com>
    * Add launch argument
    ---------
    Co-authored-by: Sebastian Castro <mailto:4603398+sea-bass@users.noreply.github.com>
  * Revert central differencing calculation in servo (#2203 <https://github.com/ros-planning/moveit2/issues/2203>)
    * Revert central differencing calculation in servo
    * current_joint_state_ to internal_joint_state_
  * Fix servo speed scaling YAML parameters (#2211 <https://github.com/ros-planning/moveit2/issues/2211>)
  * Reset Servo filters when starting (#2186 <https://github.com/ros-planning/moveit2/issues/2186>)
  * [Servo] Move enforcePositionLimits and enforceVelocityLimits to utilities (#2180 <https://github.com/ros-planning/moveit2/issues/2180>)
    * Move limit enforcing functions to utilities
    * Fix comments
    * Make clock const
    * Remove clock from enforcePositionLimit
    * Remove clock usage from transformTwistToPlanningFrame and applyJointUpdates
    * Remove clock from vvelocityScalingFactorForSingularity
    * Fix tests
    * Cleanups + clang-tidy
    * Minor cleanups
    * Log output formatting
  * Change servo collision checking parameters to dynamically update (#2183 <https://github.com/ros-planning/moveit2/issues/2183>)
  * Contributors: AndyZe, Sebastian Castro, Shobuj Paul, V Mohammed Ibrahim

 -- Blake Anderson <blakeanderson@utexas.edu>  Sat, 09 Sep 2023 22:00:00 -0000

ros-rolling-moveit-servo (2.7.4-2jammy) jammy; urgency=high

  * [Servo] Remove soon-to-be obsolete functions (#2175 <https://github.com/ros-planning/moveit2/issues/2175>)
    * Remove unused functions
    * Remove drift and control dimension client in tests
    * Remove gazebo specific message redundancy
  * [Servo] Restore namespace to parameters (#2171 <https://github.com/ros-planning/moveit2/issues/2171>)
    * Add  namespace to parameters
    * Minor cleanups
  * [Servo] Fix stop callback, delete pause/unpause mode (#2139 <https://github.com/ros-planning/moveit2/issues/2139>)
    Co-authored-by: AndyZe <mailto:andyz@utexas.edu>
  * [Servo] Make conversion operations into free functions (#2149 <https://github.com/ros-planning/moveit2/issues/2149>)
    * Move conversion operations to free functions
    * Optimizations
    * Fix const references
    * Readability updates
    * Remove unused header
    * Comment update
    ---------
    Co-authored-by: AndyZe <mailto:andyz@utexas.edu>
  * [Servo] Avoid unnecessary checks for initializing ik_base_to_tip_frame (#2146 <https://github.com/ros-planning/moveit2/issues/2146>)
    * Avoid unnecessary check
    * Make ik_base_to_tip_frame_ local
    * Remove use_inv_jacobian flag
    * Use nullptr instead of NULL
    * Alphabetize + clang-tidy
    * Remove unused header
  * [Servo] Update MoveIt Servo to use generate_parameter_library (#2096 <https://github.com/ros-planning/moveit2/issues/2096>)
    * Add generate_parameter_library as dependency
    * Add parameters file
    * Update parameters file
    * Fix one_of syntax
    * Add parameter generation
    * Include servo param header
    * Test if parameters are loaded
    * Make servo_node partially use ParamListener
    * Make Servo partially use ParamListener
    * Make ServoCalcs partially use ParamListener
    * Fix frame name
    * Handle parameter updates
    * Remove old param lib dependency in CollisionCheck
    * Remove old param lib dependency in ServoCalcs
    * Remove old param lib dependency in Servo
    * Remove old param lib dependency in ServoNode
    * Remove old parameter librarysources
    * Remove parameter_descriptor_builder sources
    * Update parameter library header name
    * Formatting
    * Remove old param lib headers
    * Add parameter to enable/disable continous parameter update check
    * Update pose tracking demo
    * Fix launch time parameter loading for pose tracking
    * Move PID parameters to generate_parameter_library
    * Fix launch time parameter loading for servo example
    * Fix unit tests
    * Fix interface test
    * Fix pose tracking test
    * Redorder member variable initialization
    * Cleanup
    * Group parameters
    * Make parameter listener const
    * Revert disabled lint tests
    * Fix issues from rebase
    * Apply performance suggestion from CI
    * Apply variable naming suggestion from CI
    * Apply pass params by reference suggestion by CI
    * Apply review suggestions
    * Apply review suggestions
    * Remove unused parameter
    * Change parameter listener to unique_ptr
    * Add validations for some parameters
    * Changes from review
    * Make docstring more informative
    Co-authored-by: Sebastian Castro <mailto:4603398+sea-bass@users.noreply.github.com>
    * Change validation failure from warning to error
    * Fix parameter loading in test launch files
    * Remove defaults for robot specific params


=== debian/control ===
Source: ros-rolling-moveit-servo
Section: misc
Priority: optional
Maintainer: Blake Anderson <blakeanderson@utexas.edu>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake, ros-rolling-ament-cmake-gtest <!nocheck>, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-control-msgs, ros-rolling-generate-parameter-library, ros-rolling-geometry-msgs, ros-rolling-moveit-common, ros-rolling-moveit-core, ros-rolling-moveit-msgs, ros-rolling-moveit-resources-panda-moveit-config <!nocheck>, ros-rolling-moveit-ros-planning-interface, ros-rolling-pluginlib, ros-rolling-realtime-tools, ros-rolling-ros-testing <!nocheck>, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-std-srvs, ros-rolling-tf2-eigen, ros-rolling-trajectory-msgs, ros-rolling-ros-workspace
Homepage: https://ros-planning.github.io/moveit_tutorials
Standards-Version: 3.9.2

Package: ros-rolling-moveit-servo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-control-msgs, ros-rolling-controller-manager, ros-rolling-generate-parameter-library, ros-rolling-geometry-msgs, ros-rolling-gripper-controllers, ros-rolling-joint-state-broadcaster, ros-rolling-joint-trajectory-controller, ros-rolling-joy, ros-rolling-launch-param-builder, ros-rolling-moveit-common, ros-rolling-moveit-configs-utils, ros-rolling-moveit-core, ros-rolling-moveit-msgs, ros-rolling-moveit-ros-planning-interface, ros-rolling-pluginlib, ros-rolling-realtime-tools, ros-rolling-robot-state-publisher, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-std-srvs, ros-rolling-tf2-eigen, ros-rolling-tf2-ros, ros-rolling-trajectory-msgs, ros-rolling-ros-workspace
Description: Provides real-time manipulator Cartesian and joint servoing.

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
